import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * An individual cell on a sudoku board
 */
public class cell extends Actor
{
    int value = 0, xID, yID;
    boolean clicking = false, solving = false, forced = false;
    GreenfootImage num = new GreenfootImage(50, 50);

    public cell(int xid, int yid)
    {
        solving = false;
        clicking = false;
        setImage(new GreenfootImage(50, 50));
        getImage().setColor(Color.BLACK);
        getImage().drawRect(0,0,49,49);
        xID = xid;
        yID = yid;
        value = brain.board[xID][yID];
        if(value == 0) { clicking = true; }
        num.setColor(Color.RED);
        num.setFont(new Font("Times New Roman", Font.BOLD, 20));
        update();
    }

    /**
     * Act - do whatever the actor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {   
        if(solving || (brain.can_start && !clicking) || forced) { value = brain.board[xID][yID];}
        getClicked();
        if(!solving)
            solve();
        update();
    }

    private void getClicked()
    {
        MouseInfo m = Greenfoot.getMouseInfo();
        if(Greenfoot.mouseClicked(this) && clicking)
        {
            if(m.getButton()==1 && !Greenfoot.isKeyDown("shift")) {if(value<9){value++;}else{value=0;} }
            if(m.getButton()==3 && !Greenfoot.isKeyDown("shift")) {if(value>0){value--;}else{value=9;} }
            else if(m.getButton()==1 && Greenfoot.isKeyDown("shift")) {value=0;}
            else if(m.getButton()==3 && Greenfoot.isKeyDown("shift")) {forced = true; num.setColor(Color.BLUE);}
        }
    }

    private void solve()
    {
        if(Greenfoot.isKeyDown("space")) { solving = true; }
    }

    void update()
    {
        if(brain.can_start)
        {
            num.clear();
            if(!clicking) { num.setColor(Color.BLACK); }
            num.drawString(Integer.toString(value), 18, 33);
            getImage().clear();
            getImage().setColor(Color.BLACK);
            getImage().drawRect(0,0,49,49);
            getImage().drawImage(num, 0, 0);
        }
    }
}
