import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A sudoku board generator that uses recursion and backtracking to try and solve a puzzle.
 * If the puzzle cannot be solved, change a random default space and try again. Depends on brain class.
 */
public class generator extends Actor
{
    int timer = 0;
    boolean solved = false;
    public generator()
    {
        timer = 0;
        solved = false;
        restart();
    }

    void restart()
    {
        try
        {
            solve(0,0);
        }
        catch(Exception ex) { /** Kept getting errors... */ solved = true; brain.can_start = true; brain.updateView(); }
    }

    boolean checkColumn(int c, int n)
    {
        for(int r = 0; r < 9; r++ )
        {
            if(brain.board[r][c] == n)
            {
                return false;
            }
        }
        return true;
    }

    boolean checkLine(int r, int n)
    {
        for(int c = 0; c<9; c++)
        {
            if(brain.board[r][c] == n)
            {
                return false;
            }
        }
        return true;
    }

    public boolean checkBox(int i, int j, int n)
    {
        i=(i/3)*3;
        j=(j/3)*3;

        for(int r=0; r<3; r++)
        {
            for(int c=0; c<3; c++)
            {
                if(brain.board[i+r][j+c] == n)
                {
                    return false;
                }
            }
        }
        return true;
    }

    public void act()
    {
        timer++;
        if(timer>=1 && !solved) { timeOut(); }
    }

    public void timeOut()
    {
        int i = Greenfoot.getRandomNumber(9);
        int j = Greenfoot.getRandomNumber(9);
        for(int n=1; n<10; n++)
        {
            if(checkLine(i,n) && checkColumn(j,n) && checkBox(i,j,n))
            {
                if(brain.ini_board[i][j] != 0)
                {
                    brain.board[i][j] = n; timer = 0; restart();
                }
            }
        }
    }

    public void solve(int r, int c) throws Exception
    {
        if(r>8) { solved = true; brain.can_start = true; brain.updateView(); throw new Exception("Done"); }
        if(brain.board[r][c] != 0)
            next(r,c) ;
        else
        {
            for(int n=1; n<10; n++)
            {
                if(checkLine(r,n) && checkColumn(c,n) && checkBox(r,c,n))
                {
                    brain.board[r][c]=n;
                    next(r, c) ;
                }
            }
            brain.board[r][c]=0;
        }
    }

    public void next(int r, int c) throws Exception
    {
        if(c < 8) { solve(r,c+1); }
        else { solve(r+1,0); }
    }
}
